/*
 *  ==================================================================
 *  Requirement.java: This class defines a single textual requirement.
 *
 *  Written by: Mark Austin                                 March 2012
 *  ==================================================================
 */

package adapter02;

import java.lang.Math.*;

public class Requirement {
    String sName;
    String sDescription;
    double dValue;

    // Constructor 

    public Requirement() {}

    public Requirement( String sName, String sDescription ) {
        this.sName = sName;
        this.sDescription = sDescription;
        this.dValue = 0.0;
    }

    // Set and get requirement name ...

    public void setName( String sName ) {
        this.sName = sName;
    }

    public String getName() {
        return this.sName;
    }

    // Set and get requirement description ...

    public void setDescription( String sDescription ) {
        this.sDescription = sDescription;
    }

    public String getDescription() {
        return this.sDescription;
    }

    // Set and get value of requirement ...

    public void setValue( double dValue ) {
        this.dValue = dValue;
    }

    public double getValue() {
        return this.dValue;
    }

    // Copy Requirement parameters to a string format ...

    public String toString() {
       return "Req(" + sName + ") is (" + sDescription + "): value = " + dValue;
    }

    // Exercise methods in class Circle ...

    public static void main( String [] args ) {

       System.out.println("Exercise methods in class Requirement");
       System.out.println("=====================================");

       Requirement rA = new Requirement();
       rA.setName ("1.0");
       rA.setDescription("My first requirement");
       rA.setValue( 3.0 );

       System.out.println("Requirement" );
       System.out.println( rA );
    }
}
