/*
 * ===========================================================================
 * RunAdapterPattern.java: Use a RequirementsTableModel adapter interface to 
 *                         link individual requirements to a JTable view.
 *
 * Written By: Mark Austin                                          March 2012
 * ===========================================================================
 */

package adapter02;

import java.awt.Component;
import java.awt.Font;

import javax.swing.*;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;

public class RunAdapterPattern { 
   public static void main(String[] args) {

      // Initialize user interface fonts ....

      Font font = new Font("Dialog", Font.PLAIN, 18);
      UIManager.put("Table.font", font);
      UIManager.put("TableHeader.font", font);

      // Generate a small set of requirements ...

      Requirement r1 = new Requirement("1.1", "My first requirement" );
      Requirement r2 = new Requirement("1.2", "My second requirement" );
      Requirement r3 = new Requirement("1.3", "My third requirement" );
      Requirement r4 = new Requirement("1.4", "My fourth requirement" );
      Requirement r5 = new Requirement("1.5", "My fifth requirement" );
      Requirement r6 = new Requirement("1.6", "My sixth requirement" );
      Requirement r7 = new Requirement("1.7", "My seventh requirement" );

      // Create a requirements table model ...

      Requirement ra [] = { r1, r2, r3, r4, r5, r6, r7 };
      RequirementsTableModel rtm = new RequirementsTableModel( ra );

      // Create and view table model.
        
      JTable table = new JTable( rtm );
      table.setRowHeight(36);

      JScrollPane pane = new JScrollPane(table);
      pane.setPreferredSize( new java.awt.Dimension(800, 250) );

      // Create and display frame ....

      JFrame frame = new JFrame("Requirements Table View");
      frame.getContentPane().add( pane );
      frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);  
      frame.pack();
      frame.setVisible(true);
   }
}
