// MYOSM.java
// Make Your Own Stock Market: A simple stock market simulator that contains a
// few stocks and their current prices (and deltas).  It randomly adjusts the 
// prices on stocks to give a dynamic feel to the data.
//

package adapter03;

import javax.swing.*;
import java.awt.*;
import java.util.*;

public class StockMarket implements Runnable {

  Stock[] market = {
    new Stock( "MSFT",  28.00),
    new Stock( "AAPL", 350.00),
    new Stock(   "BP",  47.00),
    new Stock(   "GE",  16.00),
    new Stock(    "T",   6.00),
    new Stock(  "NOK",   8.00),
    new Stock( "AMZN", 175.00)
  };    

  boolean monitor;
  Random rg = new Random();
  Thread runner;

  // Not meant to be shown as a real frame

  public StockMarket() {
     runner = new Thread(this);
     runner.start();
  }

  // Here's the heart of our stock market. In an infinite loop, just pick a
  // random stock and update its price. To make the program interesting, we'll
  // update four stocks every second.

  public void run() {
    while(true) {
      int whichStock = Math.abs(rg.nextInt()) % market.length;
      double delta = 2.0*(rg.nextDouble() - 0.4);
      market[whichStock].update(delta);
      if (monitor) {
          market[whichStock].print();
      }
      try {
        Thread.sleep(250);
      }
      catch(InterruptedException ie) {
      }
    }
  }

  public Stock getQuote(int index) {
    return market[index];
  }

  // This method returns the list of all the symbols in the market table

  public String[] getSymbols() {
    String[] symbols = new String[market.length];
    for (int i = 0; i < market.length; i++) {
      symbols[i] = market[i].symbol;
    }
    return symbols;
  }
}
