/*
 *  ==================================================================
 *  BaseList.java: Base List abstraction ...
 *  ==================================================================
 */

package bridge02;

public class BaseList {
    protected ListInterface implementor;
    
    public void setImplementor( ListInterface impl ){
        implementor = impl;
    }
    
    public void add( String item ){
        implementor.addItem(item);
    }

    public void add(String item, int position ){
        if ( implementor.supportsOrdering() ) {
             implementor.addItem(item, position);
        }
    }
    
    public void remove(String item){
        implementor.removeItem(item);
    }
    
    public String get(int index){
        return implementor.getItem(index);
    }
    
    public int count(){
        return implementor.getNumberOfItems();
    }
}
