/*
 *  ======================================================================
 *  RunBridgePattern.java: Exercise methods in bridge pattern...
 *  ======================================================================
 */

package bridge02;

public class RunBridgePattern {

    public static void main(String [] arguments){

        System.out.println("=============================");
        System.out.println("Run Bridge pattern           ");
        System.out.println("=============================");

        // Create ordered list object ... 

        ListInterface implementation = new OrderedListImpl();

        // Create baseline object ... 
        
        BaseList listOne = new BaseList();

        // Assign ordered list implementation to base ...

        listOne.setImplementor(implementation);

        // Now add elements to the list ...

        listOne.add("One");
        listOne.add("Two");
        listOne.add("Three");
        listOne.add("Four");

        // Create an ornamented list object ...
        
        OrnamentedList listTwo = new OrnamentedList();
        listTwo.setImplementor(implementation);
        listTwo.setItemType('+');

        // Create an numbered list object ...
        
        NumberedList listThree = new NumberedList();
        listThree.setImplementor(implementation);
        System.out.println();

        // Print contents of the base list ...
        
        System.out.println("Printing out first list (BaseList)");
        for (int i = 0; i < listOne.count(); i++){
            System.out.println("\t" + listOne.get(i));
        }
        System.out.println();

        // Print contents of the ornamented list ...
        
        System.out.println("Printing out second list (OrnamentedList)");
        for (int i = 0; i < listTwo.count(); i++){
            System.out.println("\t" + listTwo.get(i));
        }
        System.out.println();

        // Print contents of the numbered list ...
        
        System.out.println("Printing our third list (NumberedList)");
        for (int i = 0; i < listThree.count(); i++){
            System.out.println("\t" + listThree.get(i));
        }
    }
}

