/* 
 *  =========================================================================
 *  FaxErrorHandler.java: Process message if the text contains "Fax".
 *  Otherwis,e pass to next handler in chain of responsibility.
 *  =========================================================================
 */ 

package chain01;

public class FaxErrorHandler implements Receiver {
   private Receiver nextReceiver;

   @Override
   public void nextErrorHandler(Receiver nextReceiver) {
      this.nextReceiver = nextReceiver;
   }

   @Override
   public boolean handleMessage(Message message) {

      if (message.text.contains("Fax")) {
         System.out.printf("--- Processed by FaxErrorHandler ... \n");
         System.out.printf("---   Message priority: %s ...\n", message.priority );
         System.out.printf("---   Message text: %s ...\n", message.text );
         return true;
      } else {
         if (nextReceiver != null)
             nextReceiver.handleMessage(message);
      }
      return false;
   }	
}

