/* 
 *  ================================================================
 *  CompositeHierarchy.java: Hierarchy of composite/furniture items.
 *  ================================================================
 */ 

package composite01;

import java.util.ArrayList;

public class CompositeHierarchy implements PrintView {
    private static int iCurrentLevel = 0;
    private String sName;

    // Collection of child printitems.

    private ArrayList<PrintView> children = new ArrayList<PrintView>();
 
    // Constructor for composite hierarchy ...

    public CompositeHierarchy( String sName ) {
       this.sName = sName;
    }

    // Print the composite graphic.

    public void print() {

       // Increment level ...

       iCurrentLevel = iCurrentLevel + 1;
       System.out.printf("*** Start level %1d : %s\n", iCurrentLevel, sName );

       // Loop to print the children items ....

       for (PrintView printview : children) {
             printview.print();
       }

       // Decrement level ...

       System.out.printf("*** Finish level %1d : %s\n", iCurrentLevel, sName );
       iCurrentLevel = iCurrentLevel - 1;
    }
 
    // Add composite/furniture item to the composition.

    public void add( PrintView printitem ) {
        children.add( printitem );
    }
 
    // Remove composite/furniture item the composition.

    public void remove( PrintView printitem ) {
        children.remove( printitem );
    }
}
