/* 
 *  ==========================================================
 *  Polygon.java: Draw polygon component ....
 *  ==========================================================
 */ 

package composite02;

import java.awt.*;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.*;
import java.awt.Point;
import javax.swing.*;
import java.util.ArrayList;

public class Polygon implements Graphic {
    ArrayList<Integer> xPoints;
    ArrayList<Integer> yPoints;
    int iX, iY;

    public Polygon ( int iX, int iY, ArrayList xPoints, ArrayList yPoints ) {
       this.iX = iX; this.iY = iY;
       this.xPoints = xPoints;
       this.yPoints = yPoints;
    }

    public void draw( Graphics2D g2D ) {
       int x0, x1, y0, y1;
       g2D.setColor( Color.black );
       g2D.setStroke( new BasicStroke(10) );

       // Walk around perimeter of polygon ....

       for ( int k = 1; k < xPoints.size(); k++ ) {
          x0 = xPoints.get(k-1); y0 = yPoints.get(k-1);
          x1 = xPoints.get(k);   y1 = yPoints.get(k);
          g2D.draw( new Line2D.Double( x0, y0, x1, y1 ));
       }

       // Draw edge connecting first node to the last node ...

       x0 = xPoints.get(0); y0 = yPoints.get(0);
       x1 = xPoints.get( xPoints.size() - 1);
       y1 = yPoints.get( yPoints.size() - 1);
       g2D.draw( new Line2D.Double( x0, y0, x1, y1 ));
    }
}
 
