package factory03;

public class TestFactoryMethod {
   public static void main(String[] args) {
      int a = 9, b = 8;

      System.out.printf("Test FactoryMethod Operations ...\n"); 
      System.out.printf("============================================= ...\n"); 

      System.out.printf("--- a = %d ...\n", a );
      System.out.printf("--- b = %d ...\n", b );

      // Create add operation factory ...

      IOperationFactory operationFactory = new AddOperationFactoryImpl();
      IOperation operation = operationFactory.createOperation();

      int result = operation.getResult(a, b); // 1887

      System.out.printf("--- a + b = %d ...\n", result);

      // Create sub operation factory ...

      operationFactory = new SubOperationFactoryImpl();
      operation = operationFactory.createOperation();
      result = operation.getResult(a, b); // 111

      System.out.printf("--- a - b = %d ...\n", result);

      // Create mul operation factory ...
		
      operationFactory = new MulOperationFactoryImpl();
      operation = operationFactory.createOperation();
      result = operation.getResult(a, b); // 887112

      System.out.printf("--- a * b = %d ...\n", result);

      // Create div operation factory ...

      operationFactory = new DivOperationFactoryImpl();
      operation = operationFactory.createOperation();
      result = operation.getResult(a, b); // 1

      System.out.printf("--- a / b = %d ...\n", result);

      System.out.printf("============================================= ...\n"); 
		
   }
}
