/*
 *  ==================================================================
 *  AbstractColleague.java: Methods for an abstract colleague. Notice
 *  that is uses the mediator interface.
 *  ==================================================================
 */

package mediator01;

public abstract class AbstractColleague {
   private Mediator mediator;
   private String      sName;

   public AbstractColleague(Mediator m) {
      mediator = m;
   }

   // Set and get name ....

   public void setName ( String sName ) {
      this.sName = sName;
   }

   public String getName () {
      return sName;
   }

   // Send a message via the mediator

   public void send(String message) {
      mediator.send(message, this);
   }
	
   // Get access to the mediator

   public Mediator getMediator() {
      return mediator;
   }

   public abstract void receive(String message);	
}
