/*
 * ================================================================
 * RunPattern.java
 *
 * Created on January 10, 2007, 1:59 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 * ================================================================
 */

package mvc02;

import mvc02.controller.DefaultController;
import mvc02.model.DocumentModel;
import mvc02.view.AbstractViewPanel;
import mvc02.view.DisplayViewPanel;
import mvc02.view.PropertiesViewPanel;
import mvc02.model.TextElementModel;

import java.awt.BorderLayout;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.WindowConstants;

/**
 *
 * @author Robert Eckstein
 */

public class RunPattern {
    
    // Creates a new instance of the MVC design pattern ....

    public RunPattern() {
        
        TextElementModel textElementModel = new TextElementModel();
        DocumentModel documentModel       = new DocumentModel();

        DefaultController controller = new DefaultController();
        
        DisplayViewPanel    displayViewPanel    = new DisplayViewPanel(controller);       
        PropertiesViewPanel propertiesViewPanel = new PropertiesViewPanel(controller);
        
        controller.addView(displayViewPanel);
        controller.addView(propertiesViewPanel);
        controller.addModel(textElementModel);
        controller.addModel(documentModel);
        
        textElementModel.initDefault();
        documentModel.initDefault();        
        
        JFrame displayFrame = new JFrame("Display (View 1)");
        displayFrame.getContentPane().add(displayViewPanel, BorderLayout.CENTER);
        displayFrame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        displayFrame.pack();
        
        JDialog propertiesDialog = new JDialog(displayFrame, "Properties (View 2)");
        propertiesDialog.setModal(false);
        propertiesDialog.getContentPane().add(propertiesViewPanel, BorderLayout.CENTER);
        propertiesDialog.pack();
        
        displayFrame.setVisible(true);
        propertiesDialog.setVisible(true);
    }
    
    public static void main(String[] args) {
        RunPattern mvc = new RunPattern();
    }
}
