/**
 * ==============================================================
 * TestCircleApplication.java: Demonstrate MVC with non-modular
 * implementation of JavaFX ....
 * 
 * Written by: Mark Austin                            March, 2023 
 * ==============================================================
 */

package mvc03;

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.stage.Stage;

import mvc03.controller.MainController;
import mvc03.model.MainModel;
import mvc03.view.MainViewJavaFX;

public class TestCircleApplication {
   private static MainModel           model;
   private static MainController controller;
   private static MainViewJavaFX       view;

   public static void main(String[] args) {

      System.out.printf("--- Enter TestCircleApplication.main() ...\n");

      System.out.printf("--- Create MVC models ...\n");

      model      = new MainModel();
      controller = new MainController(model);
      view       = new MainViewJavaFX( model, controller );
      view.setSize( 700, 700 );
      view.display();

      System.out.printf("--- Leave TestCircleApplication.main() ...\n");
   }
}
