/*
 *  =======================================================================
 *  TestObserver.java: Observer design pattern implemented as a thread.
 *
 *  Written by: Mark Austin                                       June 2012
 *  =======================================================================
 */

package observer02;

import java.util.Observable;
import java.util.Observer;

public class TestObserver {
  public static void main(String[] args) {

    // Create a thread process that will be observed ...

    MyObservable observable = new MyObservable();

    // Create three processses that will observe MyObservable().

    MyObserver observer1 = new MyObserver("A1");
    MyObserver observer2 = new MyObserver("B1");
    MyObserver observer3 = new MyObserver("C1");

    // Register observers with observable process ...
 
    observable.addObserver(observer1);
    observable.addObserver(observer2);
    observable.addObserver(observer3);

    // Start observer processes ....

    observer1.start();
    observer2.start();
    observer3.start();

    // Start observable process .....

    observable.start();
    try {
      Thread.sleep(100);
    } catch (InterruptedException e) {
      e.printStackTrace();
    }
  }
}
