/*
 *  ===========================================================
 *  TestIntervalAssembly.java. Create a line of three nodes and
 *                             two intervals.
 * 
 *  Written By: Mark Austin                           June 2012 
 *  ===========================================================
 */

package observer04;

public class TestIntervalAssembly {
   public static void main(String[] args) {

      // Create a line of three nodes ...

      Node node01 = new Node( 0.0, 0.0);
      Node node02 = new Node( 5.0, 0.0);
      Node node03 = new Node(10.0, 0.0);

      // Define intervals between nodes ...

      Interval int01 = new Interval(1, node01, node02 );
      Interval int02 = new Interval(2, node02, node03 );

      // Print details of the nodes and intervals ...

      System.out.println( "Nodes ... " );
      System.out.println( "==========================" );

      System.out.println( node01 );
      System.out.println( node02 );
      System.out.println( node03 );

      System.out.println( "Intervals ... " );
      System.out.println( "==========================" );

      System.out.println( int01 );
      System.out.println( int02 );

      // Register intervals as node event listeners ...

      node01.addNodeListener( int01 );
      node02.addNodeListener( int01 );
      node02.addNodeListener( int02 );
      node03.addNodeListener( int02 );

      // Move node 3 to coordinate (6,0).
      // This will affect interval 2. 

      node03.move( 2.0, 0.0 );

      // Move node 2 to coordinate (6,0).
      // This will affect intervals 1 and 2. 

      node02.move( 1.0, 0.0 );
   }
}
