/**
 *  ========================================================================
 *  Context.java: Maintain a reference to the current strategy object.
 *  
 *  Notice that the context doesn't know anything about concrete Strategy
 *  classes, it only knows about the Strategy interface....
 *  ========================================================================
 */

package strategy01;

public class Context {
   private Strategy strategy;
  
   public void setAddStrategy() {
      this.strategy = new ConcreteStrategyAdd();
   }

   public void setMultiplyStrategy() {
      this.strategy = new ConcreteStrategyMultiply();
   }

   public void setSubtractStrategy() {
      this.strategy = new ConcreteStrategySubtract();
   }

   public int execute(int a, int b) {
      return strategy.execute(a, b);
   }
}

