/*
 *  ==============================================================
 *  Location.java: Store (x,y,z) location of a geographic feature.
 *  ==============================================================
 */

package visitor02.model;

public class Location implements Cloneable {
   public double dX, dY;

   // Constructor methods ....

   public Location() { } 

   public Location( double dX, double dY ) {
      this.dX = dX;
      this.dY = dY;
   } 

   // Create clone (i.e., deep copy) of Location object ...

   public Object clone() {
      try {
         Location coord = (Location) super.clone();
         return coord; 
      } catch (CloneNotSupportedException e) {
         return null;
      }
   }
}
