/*
 * ===================================================================
 * Tree.java: Create a tree ...
 * ===================================================================
 */

package visitor02.model.compound;

import visitor02.model.*;
import visitor02.model.primitive.*;

public class Tree extends AbstractCompoundFeature {

   // Constructor methods ...

   public Tree() {}

   public Tree ( double dX, double dY ) {
      super ( dX, dY );
      setHeight( (double) 0.0 );
      setWidth(  (double) 0.0 );

      // Create vertex for tree schematic ...

      Point node01 = new Point( "base", dX, dY );

      // Add point to the model ...

      items.put( node01.getName(), node01 );
   }

   // Accept method for Feature Element visitor ...

   public void accept( FeatureElementVisitor visitor ) {
      visitor.visit(this);
   }

   // Create string representation of tree model ....

   public String toString() {
      String s = "Tree: Name = " + sName + "\n";
      s = s    + "     " + "Location (x,y) = (" + getX() + "," + getY() + ")";

      return s;
   }
}
