/*
 * ===================================================================
 * Tree.java: Create a tree ...
 * ===================================================================
 */

package visitor03.model.compound;

import visitor03.model.*;
import visitor03.model.primitive.*;

public class Tree extends AbstractCompoundFeature implements LocationListener {
   Point node01 = null;
   public boolean DEBUG = true;

   // Constructor methods ...

   public Tree() {}

   public Tree ( double dX, double dY ) {
      super ( dX, dY );
      setHeight( (double) 0.0 );
      setWidth(  (double) 0.0 );

      // Create vertex for tree schematic ...

      node01 = new Point( "base", dX, dY );

      // Add point to the model ...

      items.put( node01.getName(), node01 );

      // Add this item to list of location listeners ....

      c.addLocationListener ( this );
   }

   // Implementation of location event handlers

   public void nodeMoved( LocationEvent evt ) {
      if ( DEBUG == true ) {
         System.out.println("*** In model.compound.Tree.nodeMoved() ... ");
      }
      double x = c.getX();
      double y = c.getY();

      node01.setX ( x );
      node01.setY ( y );
   }

   // Accept method for Feature Element visitor ...

   public void accept( FeatureElementVisitor visitor ) {
      visitor.visit(this);
   }

   // Create string representation of tree model ....

   public String toString() {
      String s = "Tree: Name = " + sName + "\n";
      s = s    + "     " + "Location (x,y) = (" + getX() + "," + getY() + ")";

      return s;
   }
}
