/*
 * ================================================================
 * SalesOfferVisitor.java: Assemble details of the sales offer ...
 * ================================================================
 */

package visitor04;

public class SalesOfferVisitor implements Visitor {
   StringBuilder offer = new StringBuilder();

   // Visit various kinds of items ...

   @Override
   public void visit(Book book) {
      offer.append("Book: isbn " +  book.getISBN() + " discount 25% ...\n");
   }

   @Override
   public void visit(Vegetable vegetable) {
      offer.append("Vegetable: No discount ... \n");
   }

   @Override
   public void visit(Fruit fruit) {
      offer.append("Fruit:     No discount ... \n");
   }

   // Retrieve string representation of the sales offer ...

   public String toString() {
      return offer.toString();
   }
}
